#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

#define MAX 1000002
#define MAX1 1003
#define MAX2 1000

#undef DEBUG

#define D_U 1
#define D_D 2
#define D_L 4
#define D_R 8
/*               0  1    2    3  4    5  6  7  8   */
char dirch[] = { 0, 'u', 'd', 0, 'l', 0, 0, 0, 'r' };
char xch[]   = { 0, 0,    0,  0, -1,  0, 0, 0, 1   };
char ych[]   = { 0, -1,   1,  0, 0,   0, 0, 0, 0   };

int xn, yn, maxlen, mlen[2], mwlen[2];
char mway[2][MAX], way[MAX];
int mcross[2][MAX], cross[MAX];
char lab[MAX2][MAX1];

int
main()
{
  char b[8192], *cp;
  int n, i;

  fgets(b, 8192, stdin);
  n = atoi(b);

  while (n-- > 0) {
    fgets(b, 8912, stdin);
    xn = strtol(b, &cp, 10);
    yn = strtol(cp, NULL, 10);
    for (i=0; i<yn; i++) {
      fgets(lab[i], MAX1, stdin);
    }
    traverse();
    printf("Maximum rope length is %d.\n", maxlen);
  }

  exit(0);
}

int
traverse(void)
{
  int x, y;

  for (x=0; x<xn; x++) {
    for (y=0; y<yn; y++) {
      if (lab[y][x] == '.')
	goto found;
    }
  }
 found:

  maxlen = 0;
  mlen[0] = mlen[1] = 0;
  mwlen[0] = mwlen[1] = 0;
  /*  mx[0][0] = mx[1][0] = x;*/
  /*  my[0][0] = my[1][0] = y;*/
  lab[y][x] = '/';

  if (lab[y][x+1] == '.') {
    way[0] = 'r';
    cross[0] = 0;
    trav_r(x+1, y, 1, 1);
  }
  if (lab[y+1][x] == '.') {
    way[0] = 'd';
    cross[0] = 0;
    trav_r(x, y+1, 1, 1);
  }
}

int
trav_r(int x, int y, int len, int wlen)
{
  int nexits, i, j, dir, olddir;
  int newlen[2];

  /*  printf("> enter %d,%d %d\n", x, y, len);*/

  nexits = 1;
  olddir = 0;
  while (nexits == 1) {
    nexits = dir = 0;
    if (x > 0 && lab[y][x-1] == '.' && olddir != D_R) {
      dir |= D_L;
      nexits++;
    }
    if (y > 0 && lab[y-1][x] == '.' && olddir != D_D) {
      dir |= D_U;
      nexits++;
    }
    if (x < xn && lab[y][x+1] == '.' && olddir != D_L) {
      dir |= D_R;
      nexits++;
    }
    if (y < yn && lab[y+1][x] == '.' && olddir != D_U) {
      dir |= D_D;
      nexits++;
    }

    if (nexits == 1) {
      olddir = dir;
      len++;
      x += xch[dir];
      y += ych[dir];
    }
  }

  if (nexits) {
    lab[y][x] = '/';
    for (i=1; i<=8; i<<=1) {
      if (dir & i) {
	way[wlen] = dirch[i];
	cross[wlen] = len;
	trav_r(x+xch[i], y+ych[i], len+1, wlen+1);
      }
    }
    lab[y][x] = '.';
  }
  else {
#if DEBUG
    printf("> end found %d,%d %d\n", x, y, len);
    printf("  way: ");
    for (j=0; j<=len; j++)
      printf("(%d,%d) ", way_x[j], way_y[j]);
    printf("\n");
#endif
    
    for (i=0; i<2; i++) {
      for (j=0; j<=mwlen[i]; j++) {
	if (way[j] != mway[i][j])
	  break;
      }
      newlen[i] = mlen[i]+len -2*cross[j];
#if DEBUG
      printf("  %d: same %d len %d\n", i, j, newlen[i]);
#endif
    }

    for (i=0; i<2; i++) {
      if (newlen[i] > maxlen &&
	  (newlen[1-i] < newlen[i] || (i==0 && newlen[0] == newlen[1]))) {
#if DEBUG
	printf("  replacing %d (%d) %d\n", 1-i, maxlen, newlen[i]);
#endif
	memcpy(mway[1-i], way, wlen+1);
	memcpy(mcross[1-i], cross, wlen+1);
	mlen[1-i] = len;
	mwlen[1-i] = wlen;
	maxlen = newlen[i];
      }
    }
  }

  lab[y][x] = '.';
  /*  printf("> leave %d,%d %d\n", x, y, len);*/
  return 0;
}
