#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

typedef struct { int w; int p; } coin;
typedef unsigned int uint;

coin coins[500];
int nCoins;

uint getMin (uint tw, int c, uint max_cost)
{
  int i;
  coin *coin = coins+c;
  uint cost, best_cost = INT_MAX;

  i=tw/coin->w;

  if (coin->w*i == tw) {
    cost = coin->p*i;
    if (cost < max_cost) { best_cost = cost; }
  }
  else if (c<nCoins -1) {
    if ((i)*coin->p > max_cost) return INT_MAX;
    for (; i>=0; i--) {
      if ((cost=getMin (tw-coin->w*i, c+1, max_cost-coin->p*i)) < INT_MAX) {
        cost += coin->p*i;
        if (cost < max_cost) { best_cost = cost; max_cost = cost; }
      }
    }
  }
  return best_cost;
}

int compare (void *_a, void *_b)
{
  coin *a=(coin *)_a, *b=(coin *)_b;
  return (a->p*b->w >= b->p*a->w);
}

int
main()
{
  char b[8192], *cp;
  int T,E,F,i;
  uint min;

  fgets(b, 8192, stdin);
  T = atoi(b);

  while (T-- > 0) {
    fgets(b, 8912, stdin);
    E = strtol(b, &cp, 10);
    F = strtol(cp, NULL, 10);

    fgets(b, 8192, stdin);
    nCoins = atoi(b);

    for (i=0; i<nCoins; i++) {
      fgets(b, 8912, stdin);
      coins[i].p = strtol(b, &cp, 10);
      coins[i].w = strtol(cp, NULL, 10);
    }

    qsort (coins, nCoins, sizeof (coin), &compare);

    if (E==F) printf ("The minimum amount of money in the piggy-bank is 0.\n");
    else if ((min=getMin (F-E, 0, INT_MAX)) < INT_MAX) printf ("The minimum amount of money in the piggy-bank is %d.\n", min);
    else printf ("This is impossible.\n");
  }

  exit(0);
}
