#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <limits.h>
#include <ctype.h>

int con[26][26];
int totanf[26], totend[26];

int queue[300];
int queue_pos, queue_len;

void
queue_init()
{
  queue_len = 0;
  queue_pos = 0;
}

void
queue_add(int x)
{
  queue[queue_len] = x;
  queue_len++;
}

int
queue_get()
{
  int ret;
  ret = -1;
  if (queue_len > 0) {
    ret = queue[queue_pos];
    queue_pos++;
    queue_len--;
  }

  return ret;
}

int
main()
{
  char b[8192], *cp;
  int t, n, i, j, x;
  int anf, end;
  int possible, startchar, endchar, besucht[26];

  fgets(b, 8192, stdin);
  t = atoi(b);

  while (t-- > 0) {
    fgets(b, 8192, stdin);
    n = strtol(b, &cp, 10);
    for (i=0; i<26; i++) {
      for(j=0; j<26; j++)
	con[i][j] = 0;
      totanf[i] = 0;
      totend[i] = 0;
      besucht[i] = 0;
    }

    while (n-- > 0) {
      fgets(b, 8192, stdin);
      anf = b[0]-'a';
      end = b[strlen(b)-2] - 'a';
      con[anf][end] ++;
      totanf[anf]++;
      totend[end]++;
    }    

    possible = 1;
    startchar = -1;
    endchar = -1;

    for (i=0; i<26; i++) {
      if (totanf[i] > totend[i]) {
	if ((totanf[i] == totend[i]+1) && (startchar == -1))
	  startchar = i;
	else {
	  possible = 0;
	  break;
	}
      } else if (totanf[i] < totend[i]) {
	if ((totanf[i] == totend[i] - 1) && (endchar == -1))
	  endchar = i;
	else {
	  possible = 0;
	  break;
	}
      }
    }
    
    if (possible) {
      queue_init();
    
      /* XXX: erreiche ich alle buchstaben? */
      if (startchar > -1) {
	queue_add(startchar);
	besucht[startchar] = 1;
      } else {
	for (i=0; i<26; i++) {
	  if (totanf[i] > 0) {
	    queue_add(i);
	    besucht[i] = 1;
	    break;
	  }
	}
      }
      while ((x=queue_get()) > -1) {
	for (i=0; i<26; i++)
	  if (con[x][i] && !besucht[i]) {
	    queue_add(i);
	    besucht[i] = 1;
	  }
      }
      
      for (i=0; i<26; i++) {
	if ((totanf[i] > 0) && !besucht[i]) {
	  possible = 0;
	  break;
	}
      }
    }
    
    if (possible)
      printf("Ordering is possible.\n");
    else
      printf("The door cannot be opened.\n");
    
  }

  exit(0);
}
